using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace Benday.Timesheet.Presentation
{
    public class TimesheetEditorTaskWeekViewModel : ViewModelBase
    {
        public TimesheetEditorTaskWeekViewModel()
        {
            this.Task = new NameValuePairViewModel<string>() { Value = String.Empty };
            this.Monday = new NameValuePairViewModel<float>();
            this.Tuesday = new NameValuePairViewModel<float>();
            this.Wednesday = new NameValuePairViewModel<float>();
            this.Thursday = new NameValuePairViewModel<float>();
            this.Friday = new NameValuePairViewModel<float>();
            this.Saturday = new NameValuePairViewModel<float>();
            this.Sunday = new NameValuePairViewModel<float>();

            SubscribeValueChangeToNotifyTotalHours(this.Monday);
            SubscribeValueChangeToNotifyTotalHours(this.Tuesday);
            SubscribeValueChangeToNotifyTotalHours(this.Wednesday);
            SubscribeValueChangeToNotifyTotalHours(this.Thursday);
            SubscribeValueChangeToNotifyTotalHours(this.Friday);
            SubscribeValueChangeToNotifyTotalHours(this.Saturday);
            SubscribeValueChangeToNotifyTotalHours(this.Sunday);
        }

        private void SubscribeValueChangeToNotifyTotalHours(NameValuePairViewModel<float> day)
        {
            day.PropertyChanged += new PropertyChangedEventHandler(day_PropertyChanged);    
        }

        void day_PropertyChanged(object sender, PropertyChangedEventArgs e)
        {
            PropertyChangedHandler("TotalHours");   
        }

        private NameValuePairViewModel<string> m_task;
        public NameValuePairViewModel<string> Task
        {
            get
            {
                return m_task;
            }
            private set
            {
                m_task = value;
                PropertyChangedHandler("Task");
            }
        }

        private NameValuePairViewModel<float> m_monday;
        public NameValuePairViewModel<float> Monday
        {
            get
            {
                return m_monday;
            }
            private set
            {
                m_monday = value;
                PropertyChangedHandler("Monday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_tuesday;
        public NameValuePairViewModel<float> Tuesday
        {
            get
            {
                return m_tuesday;
            }
            private set
            {
                m_tuesday = value;
                PropertyChangedHandler("Tuesday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_wednesday;
        public NameValuePairViewModel<float> Wednesday
        {
            get
            {
                return m_wednesday;
            }
            private set
            {
                m_wednesday = value;
                PropertyChangedHandler("Wednesday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_thursday;
        public NameValuePairViewModel<float> Thursday
        {
            get
            {
                return m_thursday;
            }
            private set
            {
                m_thursday = value;
                PropertyChangedHandler("Thursday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_friday;
        public NameValuePairViewModel<float> Friday
        {
            get
            {
                return m_friday;
            }
            private set
            {
                m_friday = value;
                PropertyChangedHandler("Friday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_saturday;
        public NameValuePairViewModel<float> Saturday
        {
            get
            {
                return m_saturday;
            }
            private set
            {
                m_saturday = value;
                PropertyChangedHandler("Saturday");
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float> m_sunday;
        public NameValuePairViewModel<float> Sunday
        {
            get
            {
                return m_sunday;
            }
            private set
            {
                m_sunday = value;
                PropertyChangedHandler("Sunday");
                PropertyChangedHandler("TotalHours");
            }
        }

        public float TotalHours
        {
            get
            {
                float total = 0f;

                total += this.Monday.Value;
                total += this.Tuesday.Value;
                total += this.Wednesday.Value;
                total += this.Thursday.Value;
                total += this.Friday.Value;
                total += this.Saturday.Value;
                total += this.Sunday.Value;

                return total;
            }
            private set
            {
                PropertyChangedHandler("TotalHours");
            }
        }

        private NameValuePairViewModel<float>[] m_days;

        public NameValuePairViewModel<float>[] Days
        {
            get
            {
                if (m_days == null)
                {
                    var tempDays = new List<NameValuePairViewModel<float>>();

                    tempDays.Add(Monday);
                    tempDays.Add(Tuesday);
                    tempDays.Add(Wednesday);
                    tempDays.Add(Thursday);
                    tempDays.Add(Friday);
                    tempDays.Add(Saturday);
                    tempDays.Add(Sunday);

                    m_days = tempDays.ToArray();
                }

                return m_days;
            }
        }

    }
}
