﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Windows.Data;
using System.Windows.Controls.Theming;
using System.Reflection;

namespace Benday.Timesheet.SilverlightUI.Controls
{

    public partial class TimesheetGrid : UserControl
    {
        // DataContext change detection code
        // by http://msmvps.com/blogs/theproblemsolver/archive/2008/12/29/how-to-know-when-the-datacontext-changed-in-your-control.aspx
        public TimesheetGrid()
        {
            InitializeComponent();

            this.LayoutUpdated += OnLayoutUpdated;
        }


        private void OnLayoutUpdated(object sender, EventArgs e)
        {
            LayoutUpdated -= OnLayoutUpdated;
            ImplicitStyleManager.SetApplyMode(m_grid, ImplicitStylesApplyMode.Auto);
            ImplicitStyleManager.Apply(m_grid); // redundant call to workaround datagrid style issue)
        }

        private void m_grid_LayoutUpdated(object sender, System.EventArgs e)
        {
            SyncColumnWidths();
        }

        public void SyncColumnWidths()
        {
            SyncColumnWidths(m_grid, m_gridFooter);
        }

        private void SyncColumnWidths(DataGrid source, Grid target)
        {
            if (source == null || target == null)
            {
                return;
            }

            if (target.ColumnDefinitions.Count == source.Columns.Count)
            {
                for (int i = 0; i < target.ColumnDefinitions.Count; i++)
                {
                    target.ColumnDefinitions[i].Width = new GridLength(source.Columns[i].ActualWidth);
                }
            }
        }
    }
}
